package com.xkrs.dao;

import com.xkrs.model.entity.CameraInformation;
import com.xkrs.model.entity.DeviceManagement;
import com.xkrs.model.vo.ADD;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Locale;
import java.util.Map;

/**
 * @Author: XinYi Song
 * @Date: 2022/3/4 11:54
 */
public interface DeviceManagementDao extends JpaRepository<DeviceManagement,Long> {


    /**
     * 查询视频连接
     */
    /*,device_name,device_sn,device_type,device_manufacturer*/
    @Query(value = "SELECT device_code,live_video FROM device_management",nativeQuery = true)
    List<Map<String,String>> Videotape();

    /**
     * 查询全部设备信息
     */
    @Query(value = "SELECT * FROM device_management",nativeQuery = true)
    List<Map<String,String>> equipment();
}
