package com.xkrs.service.impl;

import com.xkrs.common.encapsulation.PromptMessageEnum;
import com.xkrs.dao.CameraDao;
import com.xkrs.dao.DeviceManagementDao;
import com.xkrs.dao.FireDao;
import com.xkrs.model.entity.CameraInformation;
import com.xkrs.model.entity.DeviceManagement;
import com.xkrs.model.vo.ADD;
import com.xkrs.service.CameraService;
import com.xkrs.util.Query;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import static com.xkrs.common.encapsulation.OutputEncapsulation.outputEncapsulationObject;

/**
 * @Author: XinYi Song
 * @Date: 2022/3/3 11:47
 */
@Service
public class CameraServiceImpl implements CameraService {
    @Resource
    private CameraDao cameraDao;

    @Resource
    private DeviceManagementDao deviceManagementDao;

    Locale locale = LocaleContextHolder.getLocale();

    @Override
    public List<CameraInformation> SelectCameraAll() {
        List<CameraInformation> cameraInformations = cameraDao.findAll();
        if (cameraInformations == null) {
            System.out.println("实现错误");
        }
        return cameraInformations;
    }

    @Override
    public boolean InsertCamera(CameraInformation cameraInformation) {

        try {
            cameraDao.save(cameraInformation);
            return true;
        } catch (Exception e) {

            return false;
        }
    }

    @Override
    public List<DeviceManagement> SelectDevice() {
        List<DeviceManagement> deviceManagements = deviceManagementDao.findAll();
        if (deviceManagements == null) {
            System.out.println("实现错误");
        }
        return deviceManagements;
    }

    @Override
    public String Videotape() {
        List<Map<String,String>> stringObjectMap = deviceManagementDao.Videotape();
        return outputEncapsulationObject(PromptMessageEnum.SUCCESS,stringObjectMap,locale);

    }

    @Override
    public String Selectequipment() {
        List<Map<String,String>> stringObjectMap = deviceManagementDao.equipment();
        return outputEncapsulationObject(PromptMessageEnum.SUCCESS,stringObjectMap,locale);
    }

    @Override
    public String InsertPaging(List<DeviceManagement> para) {
        try {


            DeviceManagement deviceManagement = new DeviceManagement();
            return "成功添加！";
        } catch (Exception e) {

            return e.getMessage();
        }
    }
}
